#version 450 core

in vec4 gl_FragCoord;

layout (std140, binding = 0) uniform Camera {
    mat4 proj_world;
    mat4 proj_ui;
    mat4 view;
} camera;

out vec4 color;

const float NOISE_RANGE = 0.05;
const float NOISE_BASE  = 0.05;

float random (vec2 st) {
    return fract(sin(dot(st.xy, vec2(12.9898,78.233))) * 43758.5453123);
}

void main() {
    vec4 pos = inverse(camera.view) * gl_FragCoord;

    vec2 ipos = floor(pos.xy);
    vec3 rbg = vec3(NOISE_BASE + NOISE_RANGE * random(ipos));

    color = vec4(rbg, 1.0);
}
