#version 450 core

layout (location = 0) in vec3 position;

layout (std140, binding = 0) uniform Camera {
    mat4 proj_world;
    mat4 proj_ui;
    mat4 view;
} camera;

layout (location = 1) uniform mat4 model;

out FragmentData {
    vec2 tex_coords;
} data;

void main() {
    data.tex_coords = position.xy + vec2(0.5);
    gl_Position = camera.proj_world * camera.view * model * vec4(position, 1.0);
}
