pub mod resources;
pub mod systems;

use specs::{Dispatcher, DispatcherBuilder, World};

use resources::Global;
use systems::Process;

pub struct Server<'a, 'b> {
    dispatcher: Dispatcher<'a, 'b>,
}

impl<'a, 'b> Server<'a, 'b> {
    pub fn new(world: &mut World) -> Self {
        world.insert(Global::default());

        let mut dispatcher = DispatcherBuilder::new()
            .with(Process::default(), "process", &[])
            .build();
        dispatcher.setup(world);

        Self { dispatcher }
    }

    pub fn process(&mut self, world: &World) {
        self.dispatcher.dispatch(world);
    }
}
